ClickOnce 4.0 package for the C++ 2008 SP1 Redist ATL Security Update

ClickOnce is a great technology that simplifies the setup and install process for the end user. I ended up in a project where there was a need to install the latest SQL Server Compact Edition 4.0 in private distribution mode in a .NET v4 solution. In theory, that’s just the case of distributing the SQL CE runtime DLL’s to the destination folder. But wait, there’s a catch. The latest SQL CE v4.0 is dependent on the Microsoft Visual C++ 2008 Service Pack 1 Redistributable Package ATL Security Update. (msvcr90.dll version 9.0.30729.4148) Well, that shouldn’t be a problem, just open up the prerequisites dialog in VS 2010 and put a check mark into….. oh darn. There is no bootstrapper package for the 2008 VC++ Redist in Visual Studio 2010, just the newest 2010 VC++ redist package.

So what to do?

Well, just create you own bootstrapper package, and here I will guide you through the steps.

First, create a new folder in the package install location for the bootstrapper. The default location is C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\Bootstrapper\Packages. Create a folder named vcredist_2008SP1_x86. Download the Microsoft Visual C++ 2008 Service Pack 1 Redistributable Package ATL Security Update and save the vcredist_x86.exe  into this new folder.

image

Create a product.xml file in the new location and enter the following:

<?xml version="1.0" encoding="utf-8" ?> 

<Product
  xmlns="http://schemas.microsoft.com/developer/2004/01/bootstrapper"
  ProductCode="Microsoft.Visual.C++.9.0.x86"
>

  <!-- Defines list of files to be copied on build -->
  <PackageFiles>
    <PackageFile Name="vcredist_x86.exe" HomeSite="VCRedistExe"/>
  </PackageFiles>
  <InstallChecks>
    <MsiProductCheck Property="VCRedistInstalled" Product="{1F1C2DFC-2D24-3E06-BCB8-725134ADF989}"/>
  </InstallChecks>
  
  <!-- Defines how to invoke the setup for the Visual C++ 10.0 redist -->
  <!-- TODO: Needs EstrimatedTempSpace, LogFile, and an update of EstimatedDiskSpace -->
  <Commands Reboot="Defer">
    <Command PackageFile="vcredist_x86.exe" 
         Arguments=' /q:a ' 
         >

      <!-- These checks determine whether the package is to be installed -->
      <InstallConditions>
        <BypassIf Property="VCRedistInstalled" Compare="ValueGreaterThanOrEqualTo" Value="3"/>
        <!-- Block install if user does not have admin privileges -->
        <FailIf Property="AdminUser" Compare="ValueEqualTo" Value="false" String="AdminRequired"/>

        <!-- Block install on Win95 -->
        <FailIf Property="Version9X" Compare="VersionLessThan" Value="4.10" String="InvalidPlatformWin9x"/>

        <!-- Block install on NT 4 or less -->
        <FailIf Property="VersionNT" Compare="VersionLessThan" Value="5.00" String="InvalidPlatformWinNT"/>

      </InstallConditions>
      
      <ExitCodes>
        <ExitCode Value="0" Result="Success"/>
        <ExitCode Value="3010" Result="SuccessReboot"/>
        <DefaultExitCode Result="Fail" FormatMessageFromSystem="true" String="GeneralFailure" />
      </ExitCodes>
      
    </Command>
  </Commands>
</Product>

 

Create a new folder inside vcredist_2008SP1_x86 and name it en. In the en folder, create a package.xml, and copy paste the following:

<?xml version="1.0" encoding="utf-8" ?>

<Package
  xmlns="http://schemas.microsoft.com/developer/2004/01/bootstrapper"
  Name="DisplayName"
  Culture="Culture"
>

    <!-- Defines a localizable string table for error messages-->
    <Strings>
        <String Name="DisplayName">Visual C++ 2008 SP1 Runtime Libraries (x86)</String>
        <String Name="Culture">en</String>
        <String Name="AdminRequired">You do not have the permissions required to install Visual C++ 2008 SP1 Runtime Libraries (x86). Please contact your administrator.</String>
        <String Name="InvalidPlatformWin9x">Installation of Visual C++ 2008 SP1 Runtime Libraries (x86) is not supported on Windows 95. Contact your application vendor.</String>
        <String Name="InvalidPlatformWinNT">Installation of Visual C++ 2008 SP1 Runtime Libraries (x86) is not supported on Windows NT 4.0. Contact your application vendor.</String>
        <String Name="GeneralFailure">A failure occurred attempting to install Visual C++ 2008 SP1 Runtime Libraries (x86).</String>
        <String Name="VCRedistExe">http://download.microsoft.com/download/9/7/7/977B481A-7BA6-4E30-AC40-ED51EB2028F2/vcredist_x86.exe</String>
    </Strings>
    
</Package>

 

Now, when you restart Visual Studio 2010, you should have a new package for the Microsoft Visual C++ 2008 Service Pack 1 Redistributable Package ATL Security Update:

image

And when the end user runs the ClickOnce setup, it will automatically install the VC++ redist if it’s not installed already.

One thought to “ClickOnce 4.0 package for the C++ 2008 SP1 Redist ATL Security Update”

Leave a Reply to miki Cancel reply

Your email address will not be published. Required fields are marked *